// Mamluk Koran Page 88 - 98 of Islamic Geometric Patters
// Thames & Hudson by Eric Broug
// ISBN 978-0-500-28721-7
// ISBN 10: 050028721XISBN 13: 9780500287217
// code by Rupert Russell February 7th 2022 v012

// reference sites
// https://x-engineer.org/linear-interpolation-extrapolation-calculator/#formula

// int scale = 800;
int scale = 900;
int counter = 0;

float raduis = 0; // holds radius of inner circle calculated in  step 5
float[] xOuterCircle = new float[13]; // store points on outer circle
float[] yOuterCircle = new float[13]; // store points on outer circle

float[] xInnerCircle = new float[13]; // store points on outer circle
float[] yInnerCircle = new float[13]; // store points on outer circle

float[] xOuterSquare = new float[99]; // store points on outer square
float[] yOuterSquare = new float[99]; // store points on outer square

float xCenter = scale / 2;
float yCenter = scale / 2;
float extraoplatedY = 0;
float m = 0; // used to calculate extrapolation points
float y3 = 0;

boolean intersect = false;
float x, y; // used to hold intersection point


void setup() {
  // size(scale,scale)
  size(1000, 1000);

 // size(400, 400);
  xOuterSquare[0] = scale;
  yOuterSquare[0] = scale/2;


  noLoop();
}

void draw() {
  translate(50, 50);
  step1(); // outer rectangle, outer circle & six intersecting lines
  step2();
  step3();
  step4();

  myLine();
  step5();
  step6();

   points(); // number points

  // save("001.png");
}

float extrapolateY(float x1, float y1, float x2, float y2, float x) {
  m = (y2 - y1) / (x2 - x1);
  return y1 + m * (x - x1);
}


float extrapolateX(float x1, float y1, float x2, float y2, float y) {
  m = (y2 - y1) / (x2 - x1);
  return x1 + ((y - y1) * (x2 - x1)) / (y2 - y1);
}
